#! /bin/sh


mkdir -p /var/run/hostapd
mkdir -p /var/run/wpa_supplicant

IFNAME="wlan0"
FMAC_KO="/komod/extdrv/hgicf.ko"
SMAC_KO="/komod/extdrv/hgics.ko ifname="wlan%d""
USB_KO="/komod/extdrv/hgic_usb.ko"
SDIO_KO="/komod/extdrv/hgic_sdio.ko"
#####################################################################################
AH_MODE="sta"
AH_SSID="mars_b_test"
AH_BRIDGE=0
AH_BEACON=100
AH_PV1=0
AH_MAC="00:55:34:78:02:45"
AH_IP="192.168.147.100"
AH_FMAC=0
AH_PSK="12345678"
AH_KEY_MGMT="NONE"
AH_FREQ_START=9080
AH_FREQ_END=9240
AH_BSS_BW=8
AH_TX_BW=8
AH_TX_MCS=25
AH_PRIMARY_CHAN=1
AH_CHANNEL=1
AH_DEBUG=0
AH_ACS=0
AH_ACS_TM=10
SDIO_FC=1
AH_BGRSSI=0
AH_TX_POWER=20
RX_REORDER=0
AP_MAX_INACTIVITY=300
HGICS_DACK=0
WMM_ONLY_PARAM=1
WMM_ENABLED=0
WMM_AC_BK_AIFS=7
WMM_AC_BK_CWMIN=7
WMM_AC_BK_CWMAX=7
WMM_AC_BK_TXOP=0
WMM_AC_BK_ACM=0
WMM_AC_BE_AIFS=3
WMM_AC_BE_CWMIN=7
WMM_AC_BE_CWMAX=7
WMM_AC_BE_TXOP=0
WMM_AC_BE_ACM=0
WMM_AC_VI_AIFS=2
WMM_AC_VI_CWMIN=6
WMM_AC_VI_CWMAX=7
WMM_AC_VI_TXOP=21
WMM_AC_VI_ACM=0
WMM_AC_VO_AIFS=2
WMM_AC_VO_CWMIN=5
WMM_AC_VO_CWMAX=6
WMM_AC_VO_TXOP=21
WMM_AC_VO_ACM=0
WMM_AC_VO_ACM=0
WMM_AUTO=
WMM_PARAM1=
WMM_PARAM2=
WMM_PARAM4=
WMM_PARAM8=
WMM_PARAM16=
PAIRED_STAS=
IF_TEST=

s1g_1M_rates="300 600 900 1200 1800 2400 2700 3000 3600 4000"
s1g_2M_rates="650 1300 1950 2600 3900 5200 5850 6500 7800"
s1g_4M_rates="1350 2700 4050 5400 8100 10800 12150 13500 16200 18000"
s1g_8M_rates="2925 5850 8775 11700 17550 23400 26325 29250 35100 39000"

#set default values
[ -z "$AH_MODE" ] && AH_MODE="ap"
[ -z "$AH_BEACON" ] && AH_BEACON="100"
[ -z "$AH_PV1" ] && AH_PV1="1"
[ -z "$AH_IP" ] && AH_IP="10.10.10.100"
[ -z "$AH_FMAC" ] && AH_FMAC="0"
[ -z "$AH_KEY_MGMT" ] && AH_KEY_MGMT="NONE"
[ -z "$AH_FREQ_START" ] && AH_FREQ_START="7800"
[ -z "$AH_FREQ_END" ] && AH_FREQ_END="8000"
[ -z "$AH_BSS_BW" ] && AH_BSS_BW="8"
[ -z "$AH_TX_BW" ] && AH_TX_BW="8"
[ -z "$AH_TX_MCS" ] && AH_TX_MCS="7"
[ -z "$AH_PRIMARY_CHAN" ] && AH_PRIMARY_CHAN="1"
[ -z "$AH_CHANNEL" ] && AH_CHANNEL="1"
[ -z "$AH_ACS" ] && AH_ACS="0"
[ -z "$AH_DEBUG" ] && AH_DEBUG="0"
[ -z "$AH_BGRSSI" ] && AH_BGRSSI="0"
[ -z "$AH_ACS_TM" ] && AH_ACS_TM="10"
[ -z "$AH_TX_POWER" ] && AH_TX_POWER="1"
[ "$AH_MODE" == "sta" ] && AH_ACS="0"
[ "$AH_ACS" == "1" ] && AH_CHANNEL="1"
[ -z "$RX_REORDER" ] && RX_REORDER="0"
[ -z "$AP_MAX_INACTIVITY" ] && AP_MAX_INACTIVITY="300"
[ -z "$HGICS_DACK" ] && HGICS_DACK="0"
[ -z "$WMM_ONLY_PARAM" ] && WMM_ONLY_PARAM="1"
[ -z "$WMM_ENABLED" ] && WMM_ENABLED="0"
[ -z "$WMM_AC_VO_AIFS" ] && WMM_AC_VO_AIFS="2"
[ -z "$WMM_AC_VO_CWMIN" ] && WMM_AC_VO_CWMIN="5"
[ -z "$WMM_AC_VO_CWMAX" ] && WMM_AC_VO_CWMAX="6"
[ -z "$WMM_AC_VO_ACM" ] && WMM_AC_VO_ACM="0"
[ -z "$WMM_AC_VO_TXOP" ] && WMM_AC_VO_TXOP="21"
[ -z "$WMM_AC_VI_AIFS" ] && WMM_AC_VI_AIFS="2"
[ -z "$WMM_AC_VI_CWMIN" ] && WMM_AC_VI_CWMIN="6"
[ -z "$WMM_AC_VI_CWMAX" ] && WMM_AC_VI_CWMAX="7"
[ -z "$WMM_AC_VI_ACM" ] && WMM_AC_VI_ACM="0"
[ -z "$WMM_AC_VI_TXOP" ] && WMM_AC_VI_TXOP="21"
[ -z "$WMM_AC_BE_AIFS" ] && WMM_AC_BE_AIFS="3"
[ -z "$WMM_AC_BE_CWMIN" ] && WMM_AC_BE_CWMIN="7"
[ -z "$WMM_AC_BE_CWMAX" ] && WMM_AC_BE_CWMAX="7"
[ -z "$WMM_AC_BE_ACM" ] && WMM_AC_BE_ACM="0"
[ -z "$WMM_AC_BE_TXOP" ] && WMM_AC_BE_TXOP="0"
[ -z "$WMM_AC_BK_AIFS" ] && WMM_AC_BK_AIFS="7"
[ -z "$WMM_AC_BK_CWMIN" ] && WMM_AC_BK_CWMIN="7"
[ -z "$WMM_AC_BK_CWMAX" ] && WMM_AC_BK_CWMAX="7"
[ -z "$WMM_AC_BK_ACM" ] && WMM_AC_BK_ACM="0"
[ -z "$WMM_AC_BK_TXOP" ] && WMM_AC_BK_TXOP="0"
[ "$WMM_ENABLED" == "1" ] && WMM_ONLY_PARAM="0"
[ -z "$WMM_AUTO" ] && WMM_AUTO=1
[ -z "$WMM_PARAM1" ] && WMM_PARAM1="0,4,4,3;0,4,4,7;21,3,4,2;21,2,3,2"
[ -z "$WMM_PARAM2" ] && WMM_PARAM2="0,6,6,3;2,6,6,7;21,5,6,2;21,4,5,2"
[ -z "$WMM_PARAM4" ] && WMM_PARAM4="0,7,7,3;2,7,7,7;21,6,7,2;21,5,6,2"
[ -z "$WMM_PARAM8" ] && WMM_PARAM8="0,8,8,3;2,8,8,7;21,7,8,2;21,6,7,2"
[ -z "$WMM_PARAM16" ] && WMM_PARAM16="0,9,9,3;2,9,9,7;21,8,9,2;21,7,8,2"
[ -n "$IF_TEST" ] && ARG_IF_TEST="if_test=$IF_TEST"
[ -n "$SDIO_FC" ] && ARG_SDIO_FC="sdio_fc=$SDIO_FC"

get_wpa_psk()
{
	psk_list=$(wpa_passphrase $1 $2|grep psk=)
	for item in $psk_list; do
		psk=$item
	done
	echo ${psk#*=}
}

rm -f /etc/hgics.conf
rm -f /etc/hostapd_s1g.conf
rm -f /etc/wpas.conf

cat > /etc/hgics.conf <<EOF
freq_start=$AH_FREQ_START
freq_end=$AH_FREQ_END
bss_bw=$AH_BSS_BW
tx_bw=$AH_TX_BW
tx_mcs=$AH_TX_MCS
acs=$AH_ACS
acs_tm=$AH_ACS_TM
primary_chan=$AH_PRIMARY_CHAN
bg_rssi=$AH_BGRSSI
chan_list=$AH_CHAN_LIST
EOF

cat > /etc/hostapd_s1g.conf <<EOF
interface=$IFNAME
driver=nl80211
logger_syslog=-1
logger_syslog_level=2
logger_stdout=-1
logger_stdout_level=2
ctrl_interface=/var/run/hostapd
ctrl_interface_group=0
country_code=CN
hw_mode=ah
ssid=$AH_SSID
dtim_period=2
beacon_int=$AH_BEACON
channel=$AH_CHANNEL
max_num_sta=255
rts_threshold=-1
fragm_threshold=-1
macaddr_acl=0
auth_algs=3
ignore_broadcast_ssid=0
wmm_only_param=$WMM_ONLY_PARAM
wmm_enabled=$WMM_ENABLED
wmm_ac_bk_cwmin=$WMM_AC_BK_CWMIN
wmm_ac_bk_cwmax=$WMM_AC_BK_CWMAX
wmm_ac_bk_aifs=$WMM_AC_BK_AIFS
wmm_ac_bk_txop_limit=$WMM_AC_BK_TXOP
wmm_ac_bk_acm=$WMM_AC_BK_ACM
wmm_ac_be_aifs=$WMM_AC_BE_AIFS
wmm_ac_be_cwmin=$WMM_AC_BE_CWMIN
wmm_ac_be_cwmax=$WMM_AC_BE_CWMAX
wmm_ac_be_txop_limit=$WMM_AC_BE_TXOP
wmm_ac_be_acm=$WMM_AC_BE_ACM
wmm_ac_vi_aifs=$WMM_AC_VI_AIFS
wmm_ac_vi_cwmin=$WMM_AC_VI_CWMIN
wmm_ac_vi_cwmax=$WMM_AC_VI_CWMAX
wmm_ac_vi_txop_limit=$WMM_AC_VI_TXOP
wmm_ac_vi_acm=$WMM_AC_VI_ACM
wmm_ac_vo_aifs=$WMM_AC_VO_AIFS
wmm_ac_vo_cwmin=$WMM_AC_VO_CWMIN
wmm_ac_vo_cwmax=$WMM_AC_VO_CWMAX
wmm_ac_vo_txop_limit=$WMM_AC_VO_TXOP
wmm_ac_vo_acm=$WMM_AC_VO_ACM
ieee80211n=0
require_ht=0
ieee80211ah=1
s1g_compatibility=0
s1g_supported_chan_width=$AH_BSS_BW
s1g_oper_chwidth=$AH_BSS_BW
rx_s1g_mcs_map=0
s1g_rx_supported_long_gi_data_rate=0
tx_s1g_mcs_map=0
s1g_tx_supported_long_gi_data_rate=0
s1g_rx_mcs_1mhz=0
s1g_tx_mcs_1mhz=0
require_s1g=1
#compressed_ssid=test
s1g_operating_class=62
s1g_pri_chan=$AH_PRIMARY_CHAN
s1g_chan_center_freq=$AH_CHANNEL
s1g_use_sta_nsts=0
s1g_basic_mcs_nsts=0
s1g_full_beacon_int=500
dot11S1GOptionImplemented=1
s1g_unscaled_interval=100
s1g_unified_scaling_factor=0
s1g_aid_switch_count=2
eapol_key_index_workaround=0
s1g_freq_start=$AH_FREQ_START
s1g_freq_end=$AH_FREQ_END
s1g_chan_bw=$AH_BSS_BW
ap_max_inactivity=$AP_MAX_INACTIVITY
s1g_chan_list=$AH_CHAN_LIST
edca_auto=$WMM_AUTO
edca_auto_1=$WMM_PARAM1
edca_auto_2=$WMM_PARAM2
edca_auto_4=$WMM_PARAM4
edca_auto_8=$WMM_PARAM8
edca_auto_16=$WMM_PARAM16
EOF

cat > /etc/wpas.conf <<EOF
ctrl_interface=/var/run/wpa_supplicant
s1g_capab=[MAX-MPDU-7991] [S1G-LONG] [SUPPORTED-BW-0] [Rx-LDPC] [TX-STBC] [RX-STBC]
dot11S1GOptionImplemented=1
rx_s1g_mcs_map=0
s1g_rx_supported_long_gi_data_rate=0
tx_s1g_mcs_map=0
s1g_tx_supported_long_gi_data_rate=0
s1g_rx_mcs_1mhz=0
s1g_tx_mcs_1mhz=0
s1g_pv1_support=1
s1g_freq_start=$AH_FREQ_START
s1g_freq_end=$AH_FREQ_END
s1g_chan_bw=$AH_BSS_BW
s1g_chan_list=$AH_CHAN_LIST
EOF

if [ x"$AH_BRIDGE" == "x1" ]; then
	echo "bridge=br0" >> /etc/hostapd_s1g.conf
	echo "bridge=br0" >> /etc/wpas.conf
fi

if [ $AH_BSS_BW == "1" ]; then
	echo "supported_rates=$s1g_1M_rates" >> /etc/hostapd_s1g.conf
	echo "basic_rates=$s1g_1M_rates" >> /etc/hostapd_s1g.conf
elif [ $AH_BSS_BW == "2" ];then
	echo "supported_rates=$s1g_2M_rates" >> /etc/hostapd_s1g.conf
	echo "basic_rates=$s1g_2M_rates" >> /etc/hostapd_s1g.conf
elif [ $AH_BSS_BW == "4" ];then
	echo "supported_rates=$s1g_4M_rates" >> /etc/hostapd_s1g.conf
	echo "basic_rates=$s1g_4M_rates" >> /etc/hostapd_s1g.conf
elif [ $AH_BSS_BW == "8" ];then
	echo "supported_rates=$s1g_8M_rates" >> /etc/hostapd_s1g.conf
	echo "basic_rates=$s1g_8M_rates" >> /etc/hostapd_s1g.conf
fi

echo "network={" >> /etc/wpas.conf
echo "    ssid=\"$AH_SSID\"" >> /etc/wpas.conf
if [ x"$AH_KEY_MGMT" == "xWPA-PSK" ]; then
echo "    proto=RSN" >> /etc/wpas.conf
echo "    key_mgmt=WPA-PSK" >> /etc/wpas.conf
echo "    pairwise=CCMP" >> /etc/wpas.conf
echo "    group=CCMP" >> /etc/wpas.conf
echo "    psk=\"$AH_PSK\"" >> /etc/wpas.conf
echo "    priority=5" >> /etc/wpas.conf
else
echo "    key_mgmt=NONE" >> /etc/wpas.conf
fi
echo "}" >> /etc/wpas.conf

if [ x"$AH_PV1" == "x1" ]; then
	echo "s1g_capab=[MAX-MPDU-7991] [S1G-LONG] [SUPPORTED-BW-0] [Rx-LDPC] [TX-STBC] [RX-STBC] [PV1-FRAME-SUPPORT]" >> /etc/hostapd_s1g.conf
	echo "s1g_pv1_support=1" >> /etc/hostapd_s1g.conf
else
	echo "s1g_capab=[MAX-MPDU-7991] [S1G-LONG] [SUPPORTED-BW-0] [Rx-LDPC] [TX-STBC] [RX-STBC]" >> /etc/hostapd_s1g.conf
fi


if [ x"$AH_KEY_MGMT" == "xWPA-PSK" ]; then
	echo "wpa=2" >> /etc/hostapd_s1g.conf
	echo "wpa_key_mgmt=WPA-PSK" >> /etc/hostapd_s1g.conf
	echo "wpa_pairwise=CCMP" >> /etc/hostapd_s1g.conf
	echo "rsn_pairwise=CCMP" >> /etc/hostapd_s1g.conf
	echo "wpa_psk=$(get_wpa_psk $AH_SSID $AH_PSK)" >> /etc/hostapd_s1g.conf	
fi


killall hostapd
killall wpa_supplicant

rmmod hgic_usb.ko
rmmod hgic_sdio.ko
rmmod hgics.ko
rmmod hgicf.ko

if [ x"$AH_FMAC" == "x1" ];then
	insmod $FMAC_KO
	insmod $SDIO_KO
	insmod $USB_KO
	sleep 2
	ifconfig $IFNAME up;ifconfig $IFNAME down
	ifconfig $IFNAME hw ether $AH_MAC
	iwpriv $IFNAME set mode=$AH_MODE	
	iwpriv $IFNAME set freq_range=$AH_FREQ_START,$AH_FREQ_END,$AH_BSS_BW
	iwpriv $IFNAME set bss_bw=$AH_BSS_BW
	iwpriv $IFNAME set tx_bw=$AH_TX_BW
	iwpriv $IFNAME set tx_mcs=$AH_TX_MCS
	iwpriv $IFNAME set tx_power=$AH_TX_POWER	
	[ -n $PAIRED_STAS ] && iwpriv $IFNAME set paired_stas=$PAIRED_STAS
	if [ x"$AH_KEY_MGMT" == "xWPA-PSK" ]; then
		iwpriv $IFNAME set key_mgmt=WPA-PSK
		iwpriv $IFNAME set wpa_psk=$(get_wpa_psk $AH_SSID $AH_PSK)
	else
		iwpriv $IFNAME set key_mgmt=NONE
	fi
	iwpriv $IFNAME set ssid=$AH_SSID
	
	if [ x"$AH_BRIDGE" == "x1" ]; then
		ifconfig $IFNAME 0.0.0.0
		brctl addif br0 $IFNAME
	else
		ifconfig $IFNAME $AH_IP netmask 255.255.255.0
	fi
	ifconfig $IFNAME up
else
	insmod $SMAC_KO $ARG_IF_TEST
	insmod $SDIO_KO
	insmod $USB_KO
	sleep 2
	if [ x"$AH_BRIDGE" == "x1" ]; then
		ifconfig $IFNAME 0.0.0.0
		ifconfig $IFNAME down
		brctl delif br0 $IFNAME
	else
		ifconfig $IFNAME $AH_IP netmask 255.255.255.0
	fi

	ifconfig $IFNAME down
	ifconfig $IFNAME hw ether $AH_MAC

	if [ x"$AH_MODE" == "xap" ]; then
		hostapd -H /etc/hostapd_s1g.conf &
	else
		wpa_supplicant -H -Dnl80211 -i$IFNAME -c /etc/wpas.conf &
	fi
fi

